
/*

    Copyright 2003-2007 Purdue University.

    Developed by: Peter Turbek, Department of Mathematics, Computer Science, and Statistics, Purdue University Calumet.


    This file is part of CaluMath.

    CaluMath is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CaluMath is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

/* This file is used to detect where in the path the CaluMath folder is, so that the files in the library folder can be read. */

(function(){
   CM_HeadSection=document.getElementsByTagName("head")[0];
   if(window.decodeURI != null){
      var pathname = decodeURI(document.location.pathname).replace(/^[\/\"\/]/,'');
   }
   else{
      var pathname = document.location.pathname.replace(/^[\/\"\/]/,'');
   };
   var pathnamematch=pathname.match(/CaluMath/);
   if(pathnamematch == null && window.opener != null){
      //In Safari and Google Chrome, when a new window is opened, the pathname is blank. In other browsers, it is the pathname of window.opener.
      pathname=decodeURI(window.opener.document.location.pathname).replace(/^[\/\"\/]/,'');
      var pathnamematch=pathname.match(/CaluMath/);
   }
   if(pathnamematch != null){
      pathname=pathname.slice(pathnamematch.index+9);
      if(pathname.match(/\\/)){
         var numberofforwardslashes= pathname.split("\\").length;
         var tempdots="";
         for(var i=1; i<numberofforwardslashes; i++){
            tempdots=tempdots+"../";
         };
         CM_DotsToCaluMathFolder=tempdots;
      }
      else if(pathname.match(/\//)){
         var numberofforwardslashes= pathname.split("/").length;
         var tempdots="";
         for(var i=1; i<numberofforwardslashes; i++){
            tempdots=tempdots+"../";
         };
         CM_DotsToCaluMathFolder=tempdots;
      }
      else{
         CM_DotsToCaluMathFolder="";
      };

      //CM_LibraryFilesArray=["Initialize.js","Global.js","GeneralizedPlot.js","Array.js","Function.js","Math.js","Number.js","String.js","DefinedFunctionClass.js","UnicodePostscript.js","PlotClass.js","SinglePlotClass.js","FunctionPlotClass.js","PointPlotClass.js","TextPlotClass.js","RectanglePlotClass.js","NewWindowClass.js","MiscellaneousClasses.js","ArcPlotClass.js","LinearPlotClass.js","AnimationPlotClass.js","InputTextClass.js","SelectClass.js","AnimationOutputClass.js","ButtonClass.js","ClickButtonClass.js", "TangentClickButtonClass.js", "HighlightClickButtonClass.js", "PointClickButtonClass.js", "RemoveClickButtonClass.js", "DiscretePlotClass.js","CompositeObjectClass.js","HtmlBlockClass.js","TableClass.js","DiscreteFunctionCollectionClass.js","CompositeAnimationPlotClass.js","BoxesClass.js","SlidingScaleClass.js","UpdatableFunctionPlotClass.js","GraphingWorkspaceFunctions.js","MultipleQuestionTemplateClass.js","Finalize.js","..//CM_Library//CM.js","..//CM_Library//NativeString.js","..//CM_Library//NativeArray.js","..//CM_Library//NativeNumber.js","..//CM_Library//NativeFunction.js","..//CM_Library//NativeBoolean.js","..//CM_Library//Atomic.js","..//CM_Library//Composite.js","..//CM_Library//Integer.js","..//CM_Library//Rational.js","..//CM_Library//Floating.js","..//CM_Library//Polynomial.js","..//CM_Library//PolynomialNativeExponents.js","..//CM_Library//Complex.js","..//CM_Library//Expression.js","..//CM_Library//Function.js","..//CM_Library//InterfaceFunction.js","..//CM_Library//StandardFunction.js","..//CM_Library//Constant.js","..//CM_Library//RealConstant.js","..//CM_Library//Sum.js","..//CM_Library//Factor.js","..//CM_Library//Quotient.js","..//CM_Library//Power.js","..//CM_Library//String.js","..//CM_Library//AbsoluteValue.js","..//CM_Library//Factorial.js","..//CM_Library//Set.js","..//CM_Library//Vector.js","..//CM_Library//Matrix.js","..//CM_Library//Sin.js","..//CM_Library//Cos.js","..//CM_Library//Tan.js","..//CM_Library//Ln.js","..//CM_Library//Log.js","..//CM_Library//Exp.js","..//CM_Library//Definitions.js","..//CM_Library//Definitions_Expressions.js","..//CM_Library//Definitions_Funtions.js","..//CM_Library//Definitions_Variables.js","..//CM_Library//Definitions_Constants.js","..//CM_Library//Sorts.js","..//CM_Library//DensePolynomial.js","..//CM_Library//SmallPrimePolynomial.js","..//CM_Library//ExpressionReference.js","..//CM_Library//Derivative.js","..//CM_Library//Integration.js"]; //,"..//CM_Library//Html.js"];
      //CM_LibraryFilesArray=["Initialize.js","Global.js","GeneralizedPlot.js","Array.js","Function.js","Math.js","Number.js","String.js","DefinedFunctionClass.js","UnicodePostscript.js","PlotClass.js","SinglePlotClass.js","FunctionPlotClass.js","PointPlotClass.js","TextPlotClass.js","RectanglePlotClass.js","NewWindowClass.js","MiscellaneousClasses.js","ArcPlotClass.js","LinearPlotClass.js","AnimationPlotClass.js","InputTextClass.js","SelectClass.js","AnimationOutputClass.js","ButtonClass.js","ClickButtonClass.js", "TangentClickButtonClass.js", "HighlightClickButtonClass.js", "PointClickButtonClass.js", "RemoveClickButtonClass.js", "DiscretePlotClass.js","CompositeObjectClass.js","HtmlBlockClass.js","TableClass.js","DiscreteFunctionCollectionClass.js","CompositeAnimationPlotClass.js","BoxesClass.js","SlidingScaleClass.js","UpdatableFunctionPlotClass.js","GraphingWorkspaceFunctions.js","MultipleQuestionTemplateClass.js","..//CM_Library//CM.js","..//CM_Library//NativeString.js","..//CM_Library//NativeArray.js","..//CM_Library//NativeNumber.js","..//CM_Library//NativeFunction.js","..//CM_Library//NativeBoolean.js","..//CM_Library//Atomic.js","..//CM_Library//Composite.js","..//CM_Library//Integer.js","..//CM_Library//Rational.js","..//CM_Library//Floating.js","..//CM_Library//Polynomial.js","..//CM_Library//PolynomialNativeExponents.js","..//CM_Library//Complex.js","..//CM_Library//Expression.js","..//CM_Library//Function.js","..//CM_Library//InterfaceFunction.js","..//CM_Library//StandardFunction.js","..//CM_Library//Constant.js","..//CM_Library//RealConstant.js","..//CM_Library//Sum.js","..//CM_Library//Factor.js","..//CM_Library//Quotient.js","..//CM_Library//Power.js","..//CM_Library//String.js","..//CM_Library//AbsoluteValue.js","..//CM_Library//Factorial.js","..//CM_Library//Set.js","..//CM_Library//Vector.js","..//CM_Library//Matrix.js","..//CM_Library//Sin.js","..//CM_Library//Cos.js","..//CM_Library//Tan.js","..//CM_Library//Ln.js","..//CM_Library//Log.js","..//CM_Library//Exp.js","..//CM_Library//Sqrt.js","..//CM_Library//Definitions.js","..//CM_Library//Definitions_Expressions.js","..//CM_Library//Definitions_Funtions.js","..//CM_Library//Definitions_Variables.js","..//CM_Library//Definitions_Constants.js","..//CM_Library//Sorts.js","..//CM_Library//DensePolynomial.js","..//CM_Library//SmallPrimePolynomial.js","..//CM_Library//ExpressionReference.js","..//CM_Library//Derivative.js","..//CM_Library//Integration.js","..//CM_Library//Html.js","Finalize.js"]; //,"..//CM_Library//Html.js"];
    CM_LibraryFilesArray=["Initialize.js","Global.js","GeneralizedPlot.js","Array.js","Function.js","Math.js","Number.js","String.js","DefinedFunctionClass.js","UnicodePostscript.js","PlotClass.js","SinglePlotClass.js","FunctionPlotClass.js","PointPlotClass.js","TextPlotClass.js","RectanglePlotClass.js","NewWindowClass.js","MiscellaneousClasses.js","ArcPlotClass.js","LinearPlotClass.js","AnimationPlotClass.js","InputTextClass.js","SelectClass.js","AnimationOutputClass.js","ButtonClass.js","ClickButtonClass.js", "TangentClickButtonClass.js", "HighlightClickButtonClass.js", "PointClickButtonClass.js", "RemoveClickButtonClass.js", "DiscretePlotClass.js","CompositeObjectClass.js","HtmlBlockClass.js","TableClass.js","DiscreteFunctionCollectionClass.js","CompositeAnimationPlotClass.js","BoxesClass.js","SlidingScaleClass.js","UpdatableFunctionPlotClass.js","GraphingWorkspaceFunctions.js","MultipleQuestionTemplateClass.js","..//CM_Library//CM.js","..//CM_Library//Sorts.js","..//CM_Library//NativeString.js","..//CM_Library//NativeArray.js","..//CM_Library//NativeNumber.js","..//CM_Library//NativeFunction.js","..//CM_Library//NativeBoolean.js","..//CM_Library//Atomic.js","..//CM_Library//Composite.js","..//CM_Library//Integer.js","..//CM_Library//Rational.js","..//CM_Library//Floating.js","..//CM_Library//Polynomial.js","..//CM_Library//PolynomialNativeExponents.js","..//CM_Library//Complex.js","..//CM_Library//Expression.js","..//CM_Library//Function.js","..//CM_Library//InterfaceFunction.js","..//CM_Library//StandardFunction.js","..//CM_Library//Constant.js","..//CM_Library//RealConstant.js","..//CM_Library//Sum.js","..//CM_Library//Factor.js","..//CM_Library//Quotient.js","..//CM_Library//Power.js","..//CM_Library//String.js","..//CM_Library//AbsoluteValue.js","..//CM_Library//Factorial.js","..//CM_Library//Set.js","..//CM_Library//Vector.js","..//CM_Library//Matrix.js","..//CM_Library//Sin.js","..//CM_Library//Cos.js","..//CM_Library//Tan.js","..//CM_Library//Ln.js","..//CM_Library//Log.js","..//CM_Library//Exp.js","..//CM_Library//Sqrt.js","..//CM_Library//Definitions.js","..//CM_Library//Definitions_Expressions.js","..//CM_Library//Definitions_Funtions.js","..//CM_Library//Definitions_Variables.js","..//CM_Library//Definitions_Constants.js","..//CM_Library//DensePolynomial.js","..//CM_Library//SmallPrimePolynomial.js","..//CM_Library//ExpressionReference.js","..//CM_Library//Derivative.js","..//CM_Library//Integration.js","..//CM_Library//Html.js","Finalize.js"]; //,"..//CM_Library//Html.js"];


      try{
/*

         if(window.opener != null && window.opener.CaluMath != null && window.opener.CaluMath.PM.PageMakerObjectArray != null ){
            for(var libraryfilescounter=0; libraryfilescounter< CM_LibraryFilesArray.length; libraryfilescounter++){
            var tempscript = document.createElement("script");
            tempscript.src=CM_DotsToCaluMathFolder+"library/"+CM_LibraryFilesArray[libraryfilescounter];
            CM_HeadSection.appendChild(tempscript);
         }

*/
         var tempwritestringarray= [];
         for(var libraryfilescounter=0; libraryfilescounter< CM_LibraryFilesArray.length; libraryfilescounter++){
            tempwritestringarray.push('<script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/'+CM_LibraryFilesArray[libraryfilescounter]+'"><\/script>');
         }
         document.write(tempwritestringarray.join(""));
      }
      catch(e){             
         document.write('<script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Initialize.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Global.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/GeneralizedPlot.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Array.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Function.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Math.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Number.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/String.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/DefinedFunctionClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/UnicodePostscript.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/PlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/SinglePlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/FunctionPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/PointPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/TextPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/RectanglePlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/NewWindowClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/MiscellaneousClasses.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/ArcPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/LinearPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/AnimationPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/InputTextClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/SelectClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/AnimationOutputClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/ButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/ClickButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/TangentClickButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/HighlightClickButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/PointClickButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/RemoveClickButtonClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/DiscretePlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/CompositeObjectClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/HtmlBlockClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/TableClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/DiscreteFunctionCollectionClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/CompositeAnimationPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/BoxesClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/SlidingScaleClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/UpdatableFunctionPlotClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/GraphingWorkspaceFunctions.js"><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/MultipleQuestionTemplateClass.js"><\/script><script type="text/javascript" src="'+CM_DotsToCaluMathFolder+'library/Finalize.js"><\/script>');
      };
   }
   else{
      alert("You do not have the CaluMath Page Maker in the CaluMath folder. It will not work properly in this case.");
   };

   if(window.CM_BeginLoadingTime != null){
      CM_CoreLoadingTime=1*CM_BeginLoadingTime+2000;

      CM_PopUpsBlockedAlertMessage=function(){

         try{
            if( window.CM_ClientAddpointsLoaded == null && ( window.CM_ProgressWindow == null || (window.CM_ProgressWindow != null && ! window.CM_ProgressWindow.closed && window.CM_ProgressWindow.document == null)) ){
               return alert("Try: It will take about "+ Math.round(14*(CM_CoreLoadingTime-CM_BeginLoadingTime)/1000)+" seconds to load this page. However any future math page you load will load immediately. You also are blocking Pop-Up Windows. This page will not work correctly unless you turn your Pop-Up Blocker Off.");
            };
         }
         catch(e){
            return alert("Catch: It will take about "+ Math.round(14*(CM_CoreLoadingTime-CM_BeginLoadingTime)/1000)+" seconds to load this page. However any future math page you load will load immediately. You also are blocking Pop-Up Windows. To prevent errors, please turn your Pop-Up Blocker Off.");
         };
      };

      if(window.CM_CoreLoadingTime != null && window.CM_BeginLoadingTime != null && CM_CoreLoadingTime-CM_BeginLoadingTime > 800 && window.opener == null){
         var templocation=window.location+"";
         var templocationmatch=templocation.match(/CaluMath/);
         if(templocationmatch != null){
            templocation = templocation.slice(0,templocationmatch.index).replace(/\\/,"/");
            templocation=templocation+"CaluMath/library/progressbar.html";
          //  CM_ProgressWindow=window.open(templocation,null,"width=350px, height=350, toolbar=yes");

              CM_OpenProgressWindowFunction= function(){
                 if(window.CM_ClientAddpointsLoaded == null){
             //       CM_ProgressWindow = window.open(templocation,null,"width=350px, height=350, toolbar=yes");
                 };
              };

            setTimeout('CM_OpenProgressWindowFunction()', 4000);
            setTimeout('CM_PopUpsBlockedAlertMessage()',7000);
         };
      };
   };




})()

