/*

    Copyright 2003-2007 Purdue University.

    Developed by: Peter Turbek, Department of Mathematics, Computer Science, and Statistics, Purdue University Calumet.


    This file is part of CaluMath.

    CaluMath is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CaluMath is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

//This file contains the names the user sees for all the objects they can create using the CaluMath Page Maker. These names are not the same as the names the CaluMath Page Maker and its associated program internally gives to them.//

CaluMath.PM.PageMakerObjectLabelName= function(){
   //Comment: The argument can be either a String indicating the type or a CaluMath.PM.PageMakerObject
    var tempobject=arguments[0];

      if(tempobject.cm_constructorname=="String"){
         var type=tempobject;
      }
      else{
         var type=tempobject.type;
      };

      if(type=="htmltext" || type=="p" || type=="h1" || type=="h2" || type=="span" || type=="div" || type=="text"){
          var selectedlabel ="Text";
          return selectedlabel;
      };
      switch(type){
      case "coordinates":
          var selectedlabel ="Math Text";
      break
      case "hideandunhidegraph":
          var selectedlabel ="Hide And Unhide Graphs";
      break
      case "comment":
          var selectedlabel ="Comment";
      break
      case "webpagename":
          var selectedlabel ="Name Web Page";
      break
      case "animationoutput":
          var selectedlabel ="Animation Output Text Box";
      break
      case "pointbrackets3":
          var selectedlabel ="Point Brackets III";
      break
      case "pointbrackets2":
          var selectedlabel ="Point Brackets II";
      break
      case "pointbrackets1":
          var selectedlabel ="Point Brackets I";
      break
      case "executeroutine":
          var selectedlabel ="Execute A Routine";
      break
      case "moveobject":
          var selectedlabel ="Move Object";
      break
      case "iframe":
          var selectedlabel ="Iframe";
      break
      case "iframecontainer":
          var selectedlabel ="Axes And Iframe Container";
      break
      case "table":
          var selectedlabel ="Table";
      break
      case "functiontable":
          var selectedlabel ="Function Table";
      break
      case "tablerow":
          var selectedlabel ="Table Row";
      break
      case "list":
          var selectedlabel ="List";
      break
      case "listitem":
          var selectedlabel ="List Item";
      break
      case "tablecell":
          var selectedlabel ="Table Cell";
      break
      case "scriptrow":
          var selectedlabel ="Table Row";
      break
      case "scriptcell":
          var selectedlabel ="Table Cell";
      break
      case "definedconstant":
          var selectedlabel ="Define A Constant";
      break
      case "definedfunction":
          var selectedlabel ="Define A Function";
      break
      case "splitfunction":
          var selectedlabel ="Define A Split Function";
      break
      case "variablename":
          var selectedlabel ="Named Object";
      break
      case "computeralgebraexpression":
          var selectedlabel ="Computer Algebra Expression";
      break
      case "newplot":
          var selectedlabel ="Draw Axes";
      break
      case "functionplot":
          var selectedlabel ="Graph Of A Function";
      break
      case "animationplot":
          var selectedlabel ="Animation Plot";
      break
      case "compositeanimation":
          var selectedlabel ="Composite Animation";
      break
      case "tangent":
          var selectedlabel ="Tangent Graph";
      break
      case "highlight":
          var selectedlabel ="Highlight A Point";
      break
      case "pointplot":
          var selectedlabel ="Plot A Point";
      break
      case "textplot":
          var selectedlabel ="Text Plot";
      break
      case "movetextplot":
          var selectedlabel ="Move Text Plot";
      break
      case "labelplot":
          var selectedlabel ="Label An Axis Coordinate";
      break
      case "linearplot":
          var selectedlabel ="Line Segment Graph";
      break
      case "addlinearplotsegment":
          var selectedlabel ="Add Segment To Line Segment Graph";
      break
      case "standardbutton":
          var selectedlabel ="Standard Button";
      break
      case "tangentclickbutton":
          var selectedlabel ="Tangent Button";
      break
      case "highlightclickbutton":
          var selectedlabel ="Highlight Button";
      break
      case "removeclickbutton":
          var selectedlabel ="Remove Graph Button";
      break
      case "endremoveclickbutton":
          var selectedlabel ="End Graph Removal Button";
      break
      case "pointclickbutton":
          var selectedlabel ="Point Button";
      break
      case "calculatorbutton":
          var selectedlabel ="Calculator Button";
      break
      case "javascriptbutton":
          var selectedlabel ="JavaScript Button";
      break
      case "enterbutton":
          var selectedlabel ="Enter Button";
      break
      case "start":
          var selectedlabel ="Start Button";
      break
      case "stop":
          var selectedlabel ="Stop Button";
      break
      case "reset":
          var selectedlabel ="Reset Button";
      break
      case "step":
          var selectedlabel ="Step Button";
      break
      case "increasespeed":
          var selectedlabel ="Increase Speed Button";
      break
      case "decreasespeedbutton":
          var selectedlabel ="Decrease Speed Button";
      break
      case "input":
          var selectedlabel ="Input Box";
      break
      case "output":
          var selectedlabel ="Axes Information Box";
      break
      case "select":
          var selectedlabel ="Graph Menu";
      break
      case "boxes":
          var selectedlabel ="Check Boxes And Radio Buttons";
      break
      case "dropdownmenu":
          var selectedlabel ="Drop Down Menu";
      break
      case "inputarea":
          var selectedlabel ="Text Area";
      break
      case "inputtext":
          var selectedlabel ="Text Box";
      break
      case "linebreak":
          var selectedlabel ="Line Break";
      break
      case "buttonaction":
          var selectedlabel ="Button Action";
      break
      case "buttonactionnext":
          var selectedlabel ="Button Action Next Click";
      break
      case "hideandunhide":
          var selectedlabel ="Hide and Unhide";
      break
      case "gettextboxvalue":
          var selectedlabel ="Get Text Box Value";
      break
      case "getboxindex":
          var selectedlabel ="Get Box or Drop Down Index";
      break
      case "putboxindex":
          var selectedlabel ="Put Box or Drop Down Index";
      break
      case "putfocus":
          var selectedlabel ="Place Focus";
      break
      case "javascript":
          var selectedlabel ="JavaScript Command";
      break
      case "puttextboxvalue":
          var selectedlabel ="Place Value In Text Box";
      break
      case "buttonaction":
          var selectedlabel ="Button Action";
      break
      case "addtobuttonaction":
          var selectedlabel ="Add To Button Action";
      break
      case "forloop":
          var selectedlabel ="For Loop";
      break
      case "addtoforloop":
          var selectedlabel ="Add To For Loop";
      break
      case "clickbutton":
          var selectedlabel ="Click On Graph Button";
      break
      case "button":
          var selectedlabel ="Button";
      break
      case "startbutton":
          var selectedlabel ="Start Button";
      break
      case "stopbutton":
          var selectedlabel ="Stop Button";
      break
      case "stepbutton":
          var selectedlabel ="Step Button";
      break
      case "changedirectionbutton":
          var selectedlabel ="Change Direction Button";
      break
      case "increasespeedbutton":
          var selectedlabel ="Increase Speed Button";
      break
      case "decreasespeedbutton":
          var selectedlabel ="Decrease SpeedButton";
      break
      case "resetbutton":
          var selectedlabel ="Reset Button";
      break
      case "nameclickedpoint":
          var selectedlabel ="Name Clicked Point";
      break
      case "removegraph":
          var selectedlabel ="Remove Graph";
      break
      case "removehtml":
          var selectedlabel ="Remove HTML";
      break
      case "comparison":
          var selectedlabel ="Comparison";
      break
      case "search":
          var selectedlabel ="Search";
      break
      case "conditional":
          var selectedlabel ="Conditional";
      break
      case "addtoconditional":
          var selectedlabel ="Add To Conditional";
      break
      case "routine":
          var selectedlabel ="Routine";
      break
      case "addtoroutine":
          var selectedlabel ="Add To Routine";
      break
      case "cm_alert":
          var selectedlabel ="Pop-Up Message Window";
      break
      case "arrow":
          var selectedlabel ="Arrow Graph";
      break
      case "bracket":
          var selectedlabel ="Bracket Graph";
      break
      case "focusobject":
          var selectedlabel ="Focus Object";
      break
      case "link":
          var selectedlabel ="Link";
      break
      case "image":
          var selectedlabel ="Image";
      break
      case "textstylesheet":
          var selectedlabel ="Set Defaults";
      break
      case "addtonewwindow":
          var selectedlabel ="Add To New Window";
      break
      case "newwindow":
          var selectedlabel ="New Window";
      break
      case "inserttablerow":
          var selectedlabel ="Insert Table Row";
      break
      case "inserttablecolumn":
          var selectedlabel ="Insert Table Column";
      break
      case "deletetablerow":
          var selectedlabel ="Delete Table Row";
      break
      case "deletetablecolumn":
          var selectedlabel ="Delete Table Column";
      break
      case "importpage":
          var selectedlabel ="Import Page";
      break
      case "endinsertionarray":
          var selectedlabel ="End Button Action, Conditional, Etc. ";
      break
      case "changebuttontype":
          var selectedlabel ="Change Button Type";
      break
      case "insertlistitem":
          var selectedlabel ="Insert List Item";
      break
      case "deletelistitem":
          var selectedlabel ="Delete List Item";
      break
      case "allanimationbutton":
          var selectedlabel ="Create All Animation Buttons";
      break
      case "arcplot":
          var selectedlabel ="Circles And Arcs";
      break
      case "labelvertex":
          var selectedlabel ="Label Vertex";
      break
      case "labelallvertices":
          var selectedlabel ="Label All Vertices";
      break
      case "changelinks":
          var selectedlabel ="Change All Links";
      break
      case "changeimages":
          var selectedlabel ="Change All Images";
      break
      case "addhtml":
          var selectedlabel ="Add Html";
      break
      case "headhtml":
          var selectedlabel ="Add Head Html";
      break
      case "activatedragpoint":
          var selectedlabel ="Activate Dragging Graphs";
      break
      case "deactivatedragpoint":
          var selectedlabel ="Deactivate Dragging Graphs";
      break
      case "namedraggedvalue":
          var selectedlabel ="Name Dragged Value";
      break
      case "dragroutine":
          var selectedlabel ="Routine For Dragging";
      break
      case "slidingscale":
          var selectedlabel ="Create Sliding Scale";
      break
      case "activateslidingscale":
          var selectedlabel ="Activate Sliding Scale";
      break
      case "deactivateslidingscale":
          var selectedlabel ="Deactivate Sliding Scale";
      break
      case "updatablefunctionplot":
          var selectedlabel ="Make Updatable Graph";
      break
      case "updatefunctionplot":
          var selectedlabel ="Update To Function Graph";
      break
      case "updateareabetweenfunctionsplot":
          var selectedlabel ="Update To Area Between Functions";
      break
      case "updatetangentplot":
          var selectedlabel ="Update To Tangent Graph";
      break
      case "updatearcplot":
          var selectedlabel ="Update To Arc Graph";
      break
      case "updatelinearplot":
          var selectedlabel ="Update To Line Segment Graph";
      break
      case "updateaddlinearplotsegment":
          var selectedlabel ="Add Line Segments to Updatable Graph";
      break
      case "updateblanksegments":
          var selectedlabel ="Update With Blank Segments";
      break
      case "movepoint":
          var selectedlabel ="Move Point";
      break
      case "moverectangle":
          var selectedlabel ="Move Rectangle";
      break
      case "rectangleplot":
          var selectedlabel ="Make A Rectangle";
      break
      case "activatedragrectangle":
          var selectedlabel ="Activate Drag Rectangles";
      break
      case "deactivatedragrectangle":
          var selectedlabel ="Deactivate Drag Rectangles";
      break
      case "deactivateclickableaxes":
          var selectedlabel ="Deactivate Clicking On Axes";
      break
      case "activateviewrectangle":
          var selectedlabel ="Activate Construct Rectangle By Dragging";
      break
      case "deactivateviewrectangle":
          var selectedlabel ="Dectivate Construct Rectangle By Dragging";
      break
      case "activatestretchrectangle":
          var selectedlabel ="Activate Stretch Rectangles";
      break
      case "deactivatestretchrectangle":
          var selectedlabel ="Deactivate Stretch Rectangles";
      break
      case "activatecapturedragpath":
          var selectedlabel ="Activate Capture Drag Path";
      break
      case "deactivatecapturedragpath":
          var selectedlabel ="Deactivate Capture Drag Path";
      break
      case "tablefromdata":
          var selectedlabel ="Table From List";
      break
      case "discretefunctionconstructiontable":
          var selectedlabel ="Discrete Function Construction Table";
      break
      case "discretefunctionfrompointsarray":
          var selectedlabel ="Discrete Function From Points Array";
      break
      case "discretefunctionplot":
          var selectedlabel ="Discrete Function Plot";
      break
      case "nameanimationvalue":
          var selectedlabel ="Name Animation Running Value";
      break
      case "animationroutine":
          var selectedlabel ="Routine For Animation";
      break
      case "rescaleaxes":
          var selectedlabel ="Rescale Axes";
      break
      case "addtoboxordropdown":
          var selectedlabel ="Add Options To Boxes or Drop Down Menus";
      break
      }
      return selectedlabel;
};