
CaluMath.Html.MultipleQuestionTemplateClass=function(){};
CaluMath.Html.MultipleQuestionTemplateClass.ReturnMultipleQuestionTemplateInformationText=function(){
var returnarray=[
'This page is a template for a series of questions that students answer by either typing their answers in a textbox, manipulating a graph, or doing some other type of action that the page can capture and evaluate. The action is cyclic: the students click the Display Question button to display the next question. They type their answer or do some sort of manipulation and click a Check Answer button to check their answer. If their answer is incorrect, you can provide a response and the student can try again. If their answer is correct, you can provide a response and the student clicks the Display Question button to display the next question, and the cycle repeats. There is a Skip Question button that allows the user to skip questions and return to them after going through the questions contained in the page. ',
'The following constants are set in the page but can be changed by the user.  ',
'<b>1. RemovePreviousQuestions is set to "yes".</b> This says that when the next question is displayed, the previous question is removed. You can instead set this to "no" if you want the previous questions to remain visible. ',
'<b>2. RemovePreviousAnswers is set to "yes".</b> This says that when the next question is displayed, the previous answer is removed. You can instead set this to "no" if you want the previous answers to remain visible. ',
'<b>3. AllowSkipQuestionButton="yes" and AllowReturnToSkippedQuestions="yes".</b> The setting for AllowSkipQuestionButton determines whether the page will contain a Skip Question button or not. If the page does not create a Skip Question button, there is no way for a student to reach the next question without correctly answering the current question. If the button is created, you then have the choice of allowing students to return to questions they skipped or not. Setting AllowReturnToSkippedQuestions="yes" means that when the student skips questions, after they have gone through the page, they can return to answer the questions they skipped. If you set AllowReturnToSkippedQuestions="no", then once a question is skipped, it cannot be viewed again. ',
'<b>4. DisplayCalculatorButton is set to "yes".</b> This says that a Calculator button will be displayed in the page. If the student clicks on this button, a new window opens where they can enter mathematical expressions that evaluate to numbers and have them evaluated. You can instead set this to "no" if you do not want the student to have access to this Calculator. ',
'<b>5. QuestionNumberArray=[1,2,3,4,5,6,7,8,9,10,11,12].</b> This Array lists the questions to be displayed. You can modify this to display less than 12 questions, or any subset of 12 questions. For example, if you change this to be [1,2,3], then only questions 1, 2, and 3 will be displayed (and you do not need to construct any remaining questions). If you change this to be [2,4,6,8,10,12], then only the even questions will be displayed. You can even have questions repeat. For example, suppose Question 1 depends on a randomly generated number <mi>A</mi>. Setting QuestionNumberArray=[1,1,1,2,3,4,5,6,7,8,9,10,11,12] will have Question 1 be displayed three times and then Questions 2 through 12 will be displayed once. You could set QuestionNumberArray to [4,4,4,1,1,2] so that the student does question 4 three times, question 1 twice and then question 2. The page automatically creates a counter, called <i>DoNotChange_DisplayedQuestionNumber</i> that can be used in your questions that displays the question number <i>as the student perceives it</i>. For example, if Question 1 is repeated three times, <i>DoNotChange_DisplayedQuestionNumber</i> will equal 1 the first time Question 1 is displayed, but then will be 2 and 3 the second and third time Question 1 is displayed. ',
'<b>6. ViewTextBoxArray=["yes","yes","yes","yes","yes","yes","yes","yes","yes","yes","yes","yes"].</b> This is an Array (which must have 12 entries) that indicates the questions for which a text box is to be created in which the student types their answer. The original value indicated above would create a text box for each question. If you modify this to ViewTextBoxArray=["yes","no","yes","no","yes","yes","yes","yes","yes","yes","yes","yes"], it means Questions 2 and 4 will not display a text box for the student to enter their answer. It is assumed that, for these questions, there is another way the student responds, for example, by dragging a point on a graph to a correct position. Note that the first entry corresponds to Question1, the second entry to Question2,..., the 12th entry corresponds to Question12, even if the questions are repeated or displayed out of order as indicated by the QuestionNumberArray. ',
'<b>7. AllowMultipleAttemptsArray=["yes","yes","yes","yes","yes","yes","yes","yes","yes","yes","yes","yes"].</b> This is an Aray that indicates whether the student can modify their answer after an incorrect response to the question. The entries in this array must correspond to the entries in the QuestionNumberArray. For example, if QuestionNumberArray= [4,4,4,1,1,2] and AllowMultipleAttemptsArray = ["yes","yes","no","yes","no","no"] it means that the first two times the student attempts question 4, they will be allowed to modify their answer if it is incorrect, however the last time they attempt question 4, they only have one chance to give an answer. Similarly, the first time they attempt question 1 they can modify their answers, however the second time they will not be able to. Finally, they will not be able to modify their answers for question 2. ',
'<b>8. InitialAxesVisibility="yes".</b> The page contains a set of axes named Axes1. You can set InitialAxesVisibility to be either "yes", if you want the axes visible when the page loads, or "no" if you do not want the axes to be seen when the page loads. ',
'<b>9. AxesVisibilityArray=["yes","no","yes","no","yes","no","yes","no","yes","no","yes","no"].</b> This is an Array (which must have 12 entries) that indicates the visibility of the axes Axes1 for each problem. Each entry can be either "yes", for the axes to be visible for that question, or "no" for the axes to not be visible for that question. The original value indicated above means that the axes will be visible for all odd problems, and invisible for all even problems. Note that the first entry corresponds to Question1, the second entry to Question2,..., the 12th entry corresponds to Question12, even if the questions are repeated or displayed out of order as indicated by the QuestionNumberArray. ',
'<b>10. AxesWidth=CM_Min(432, CM_ScreenWidth/3).</b> This is the width of the axes. Note that CM_Min is a command that gives the minimum of a list of numbers and CM_ScreenWidth is the width of the screen in the browser in pixels. This says that the width of the axes will be the minimum of 432 pixels and one third the width of the screen. If the set of axes were printed on a page, 420 pixels corresponds to 6 inches (72 pixels per inch). AxesWidth was chosen so that the axes would not be too big if the computer screen is very small (it will be 1/3 of the screen width), or too big if the computer screen is big (it will be 432 pixels). ',
'<b>11. AxesHeight=CM_Min(360, CM_Screenheight/3).</b> This is the heighth of the axes. The comments for AxesHeight are analogous to those for AxesWidth. Note that for small screens the axes height will be 1/3 of the height of the computer screen. This should help so that the user doesn\t always have to scroll up and down to view the axes and the text in the page. ',
'<b>12. DisplayZoomButtons="yes".</b> This says to display buttons that allow the user to make the axes bigger or smaller. Only the width and height of the axes change; the beginning and ending x and y values do not change. You can set DisplayZoomButtons="no" to not have the zoom buttons displayed. ',
'<b>13. QuestionParagraphColor="black", CorrectAnswerParagraphColor="green" and IncorrectAnswerParagraphColorArray=["red","orange"].</b> These are the colors in which the paragraphs for the questions, correct responses and incorrect responses, respectively, are displayed. They can be changed to any standard color, such as "blue", or an RGB color code, such as "#87ceeb". Note that the color setting for the incorrect answer paragraphs is an Array of length two that contains two colors. Originally IncorrectAnswerParagraphColorArray=["red","orange"]. The first incorrect answer will be displayed in the first color. If the student is allowed multiple attempts on the same problem, subsequent incorrect answers alternate between the two colors. The reason for this is to show the student that the page responded to their incorrect entry. If the student answered incorrectly and received the same response and the color were not different, the student might not think the page responded to their new input. ',
'There are twelve routines with the names Question1Routine, ... , Question12Routine. You need to open the page in Edit mode and click on these routines to modify them. Each of these routines contain several routines that allow you to customize what takes place in order to set up the question, how the student\'s answer or interaction should be evaluated and the responses that should be created in response to correct and incorrect answers. In these routines you can create items,such as axes,graphs,tables,etc. that you may require for a question. Inside each of the twelve routines are complete instructions. ',
'When you view the Multiple Question Template in the CaluMath Page Maker, there is a small table at the bottom that allows you make copies of questions you already constructed. For example, suppose you created Question1 and Question2 (which you haven\'t constructed yet)is similar to Question1. Using this table,you can copy Question1 and make the copy of it Question2. You can then modify the Question2 so it is exactly the question you want. In addition,using the Advanced-->Import Page item of the CaluMath Page Maker,you can import sections of any previously constructed CaluMath page;in particular you can import problems created from pages made using the Multiple Question Template. ',
'There is one Display Question button and one Check Answer Button. The program automatically makes these buttons, the questions, and the responses to questions appear at the appropriate times. <b> Most of the buttons and the routines necessary for the page to work correctly are purposely hidden. If you want to see these hidden items, check the Display Hidden Template Objects in the CaluMath Page Maker. If you do this, make sure you do not change any of the hidden objects.</b> ',
'Please read the comments that are visible when you edit the page. '];
return returnarray.join('<br><br>');};
CaluMath.Html.MultipleQuestionTemplateClass.CreateMultipleQuestionTemplateDoNotChangeItems=function(){('CM_OpeningTagSymboldiv class="math" id="DoNotChange_ButtonsContainer"   > <CM_FORWARDSLASHdiv>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertbefore, cm_inserttarget=AfterButtonsContainer,name= DoNotChange_ButtonsContainer");
CM_ParentObject.cm_button("DoNotChange_AnswerButton".cm_javascript(),"Check Answer".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=16px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,style=display=none,cm_onlyforlists=no");
CM_ParentObject.cm_button("DoNotChange_DisplayQuestionButton".cm_javascript(),"Display Question".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=16px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,style=display=n/a,cm_onlyforlists=no");
DoNotChange_CreateAnswerBox=function(){
CM_ParentObject.cm_writeinputtext("name=AnswerBox,cm_size=100,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,style=display=none,cm_onlyforlists=no");};
window["DoNotChange_CreateAnswerBox".cm_javascript()]();
"<br>".cm_html("cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,cm_onlyforlists=no,name=DoNotChange_LineBreak1");
CM_ParentObject.cm_button("DoNotChange_SkipQuestionButton".cm_javascript(),"Skip This Question".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=16px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,style=display=none,cm_onlyforlists=no");
CM_ParentObject.cm_button("DoNotChange_Calculator_StudentCalculator".cm_javascript(),"Calculator".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=16px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=DoNotChange_ButtonsContainer,style=display=none,cm_onlyforlists=no");
CM_ParentObject.cm_button("DoNotChange_ZoomInButton".cm_javascript(),"Bigger Graph".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=12px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=NavigationR0C2,style=display=n/a,cm_onlyforlists=no");
CM_ParentObject.cm_button("DoNotChange_ZoomOutButton".cm_javascript(),"Smaller Graph".cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),"style=fontSize=12px,cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertin,cm_inserttarget=NavigationR0C3,style=display=n/a,cm_onlyforlists=no");
eval("CM_ParentObject.DoNotChange_SkipQuestionButton".cm_javascript()).cm_add(function(){
CaluMath.Html.DefinedConstant("DoNotChange_SkippedQuestionArray".cm_javascript(),cm_eval("DoNotChange_SkippedQuestionArray.cm_concat(DoNotChange_QuestionNumber)"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedDisplayedQuestionArray".cm_javascript(),cm_eval("DoNotChange_SkippedDisplayedQuestionArray.cm_concat(DoNotChange_DisplayedQuestionNumber)"),"no");
window["RemoveWhenClickingCheckAnswerButtonAfterWrongAnswerRoutine".cm_javascript()]();
window["RemoveWhenClickingCheckAnswerButtonAfterWrongAnswerRoutine".cm_javascript()]();
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove!=null){window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove()};};
CM_ParentObject.DoNotChange_DisplayQuestionButton.cm_node.onclick();});
eval("CM_ParentObject.DoNotChange_Calculator_StudentCalculator".cm_javascript()).cm_add(function(){
CaluMath.Html.NewWindow("DoNotChange_Calculator_Window",[' ',' (CM_NEWWINDOWSINGLEQUOTECM_OpeningTagSymbolh1 id=CM_NEWWINDOWDOUBLEQUOTEDoNotChange_Calculator_WindowTitleCM_NEWWINDOWDOUBLEQUOTE style=CM_NEWWINDOWDOUBLEQUOTEfont-size:xx-large;text-align:center;CM_NEWWINDOWDOUBLEQUOTE  > Calculator<CM_FORWARDSLASHh1>CM_NEWWINDOWSINGLEQUOTE).cm_html(CM_NEWWINDOWDOUBLEQUOTEcm_caswindow=DoNotChange_Calculator_Window,name= DoNotChange_Calculator_WindowTitleCM_NEWWINDOWDOUBLEQUOTE);',' (CM_NEWWINDOWSINGLEQUOTECM_OpeningTagSymbolp id=CM_NEWWINDOWDOUBLEQUOTEDoNotChange_Calculator_WindowParagraphCM_NEWWINDOWDOUBLEQUOTE style=CM_NEWWINDOWDOUBLEQUOTEfont-size:x-large;CM_NEWWINDOWDOUBLEQUOTE  > In order to use this calculator, simply type an expression to evaluate in the upper text box and click the Evaluate button.  The result will be displayed in the lower text box.  Make sure you use a * to denote multiplication and use parentheses when required. The expressions you enter must evaluate to a number!<CM_FORWARDSLASHp>CM_NEWWINDOWSINGLEQUOTE).cm_html(CM_NEWWINDOWDOUBLEQUOTEcm_caswindow=DoNotChange_Calculator_Window,name= DoNotChange_Calculator_WindowParagraphCM_NEWWINDOWDOUBLEQUOTE);','  CM_ParentObject.cm_writeinputtext(CM_NEWWINDOWDOUBLEQUOTEname=DoNotChange_Calculator_Input,size=65,cm_caswindow=DoNotChange_Calculator_Window,cm_insertoption=n/a,cm_inserttarget=n/a,style=display=n/a,cm_onlyforlists=noCM_NEWWINDOWDOUBLEQUOTE); ',' CM_NEWWINDOWDOUBLEQUOTE<br>CM_NEWWINDOWDOUBLEQUOTE.cm_html(CM_NEWWINDOWDOUBLEQUOTEcm_caswindow=DoNotChange_Calculator_Window,cm_insertoption=n/a,cm_inserttarget=n/a,cm_onlyforlists=noCM_NEWWINDOWDOUBLEQUOTE); ','  CM_ParentObject.cm_button(CM_NEWWINDOWDOUBLEQUOTEDoNotChange_Calculator_EvaluateCM_NEWWINDOWDOUBLEQUOTE.cm_javascript(),CM_NEWWINDOWDOUBLEQUOTEEvaluateCM_NEWWINDOWDOUBLEQUOTE.cm_javascript().cm_unescapequotes().cm_unescapebackslashes(),CM_NEWWINDOWDOUBLEQUOTEstyle=fontSize=16px,cm_caswindow=DoNotChange_Calculator_Window,cm_insertoption=n/a,cm_inserttarget=n/a,style=display=n/a,cm_onlyforlists=noCM_NEWWINDOWDOUBLEQUOTE); ',' CM_NEWWINDOWDOUBLEQUOTE<br>CM_NEWWINDOWDOUBLEQUOTE.cm_html(CM_NEWWINDOWDOUBLEQUOTEcm_caswindow=DoNotChange_Calculator_Window,cm_insertoption=n/a,cm_inserttarget=n/a,cm_onlyforlists=noCM_NEWWINDOWDOUBLEQUOTE); ','  CM_ParentObject.cm_writeinputtext(CM_NEWWINDOWDOUBLEQUOTEname=DoNotChange_Calculator_Output,size=65,cm_caswindow=DoNotChange_Calculator_Window,cm_insertoption=n/a,cm_inserttarget=n/a,style=display=n/a,cm_onlyforlists=noCM_NEWWINDOWDOUBLEQUOTE); ',' eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_EvaluateCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_add(function(){  if(CaluMath.Html.IsEvalMath(eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value)  == CM_NEWWINDOWDOUBLEQUOTEnoCM_NEWWINDOWDOUBLEQUOTE){ return alert(CM_NEWWINDOWDOUBLEQUOTEYou must enter a number or a mathematical expression that evaluates to a number in the box.CM_NEWWINDOWDOUBLEQUOTE);} else{ if(eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value.match(/=/) ==null){ window[CM_NEWWINDOWDOUBLEQUOTEDoNotChange_Calculator_AnswerCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()]=CaluMath.Html.Round((eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value.cm_evalmath()), 8);}else{ CaluMath.Html.DefinedConstant(eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value.split(/=/)[0], eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value.split(/=/)[1],8); window[CM_NEWWINDOWDOUBLEQUOTEDoNotChange_Calculator_AnswerCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()]=eval(eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_InputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_node.value.split(/=/)[0]) } };  eval(CM_NEWWINDOWDOUBLEQUOTECM_ParentObject.DoNotChange_Calculator_OutputCM_NEWWINDOWDOUBLEQUOTE.cm_javascript()).cm_puttext(CM_NEWWINDOWDOUBLEQUOTEcm_eval(DoNotChange_Calculator_Answer)CM_NEWWINDOWDOUBLEQUOTE.cm_escapedoublequotes().cm_adjustquotes(CM_NEWWINDOWDOUBLEQUOTECM_NEWWINDOWSINGLEQUOTECM_NEWWINDOWDOUBLEQUOTE).cm_unescapebackslashes().cm_unescapequotes().cm_javascript().cm_unicode()); }); ',' ',"closewindowbutton"],"title=Calculator");});
eval("CM_ParentObject.DoNotChange_ZoomInButton".cm_javascript()).cm_add(function(){
CaluMath.Html.DefinedConstant("AxesWidth".cm_javascript(),"AxesWidth/.8",5,"");
CaluMath.Html.DefinedConstant("AxesHeight".cm_javascript(),"AxesHeight/.8",5,"");
CaluMath.Html.ZoomInOnAllAxes();});
eval("CM_ParentObject.DoNotChange_ZoomOutButton".cm_javascript()).cm_add(function(){
CaluMath.Html.DefinedConstant("AxesWidth".cm_javascript(),"AxesWidth*.8",5,"");
CaluMath.Html.DefinedConstant("AxesHeight".cm_javascript(),"AxesHeight*.8",5,"");
CaluMath.Html.ZoomOutOnAllAxes();});
eval("CM_ParentObject.DoNotChange_DisplayQuestionButton".cm_javascript()).cm_add(function(){
window["RemoveHideOrCreateBeforeEachQuestionRoutine".cm_javascript()]();
window["DoNotChange_RevealQuestionsRoutine".cm_javascript()]();
setTimeout("CaluMath.Html.Focus(CM_MainWindow.CM_ParentObject.DoNotChange_AfterInputBoxFocus, CM_MainWindow)",500);});
DoNotChange_RevealQuestionsRoutine=function(){
CaluMath.Html.DefinedConstant("StudentAnswer".cm_javascript(),undefined,"no");
CaluMath.Html.DefinedConstant("StopPageAt".cm_javascript(),DoNotChange_QuestionNumberArray.length,"no");
CaluMath.Html.DefinedConstant("DoNotChange_IncorrectAnswerParagraphColorIndex".cm_javascript(),"0",5,"yes");
if(
CaluMath.Html.ComparisonOneTerm(("1+DoNotChange_QuestionIndex").cm_evalmath(),">=",("StopPageAt").cm_evalmath())=="yes"){
if(
CaluMath.Html.Comparison([[("DoNotChange_SkippedQuestionArray.length").cm_evalmath(),">",("0").cm_evalmath(),],[AllowReturnToSkippedQuestions,"ne","no"]],"and")=="yes"){('CM_OpeningTagSymbolp id="SkippedQuestionParagraph"   > There are no more questions on this page. Click the Display Question button to return to the questions you skipped. <CM_FORWARDSLASHp>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertbefore, cm_inserttarget=CM_ParentObject.DoNotChange_AnswerButton,name= SkippedQuestionParagraph");
CaluMath.Html.DefinedConstant("DoNotChange_QuestionIndex".cm_javascript(),"-1",5,"");
CaluMath.Html.DefinedConstant("DoNotChange_QuestionNumberArray".cm_javascript(),DoNotChange_SkippedQuestionArray,"no");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedQuestionArray".cm_javascript(),[],"no");
CaluMath.Html.DefinedConstant("DoNotChange_DisplayedQuestionNumberArray".cm_javascript(),DoNotChange_SkippedDisplayedQuestionArray,"no");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedDisplayedQuestionArray".cm_javascript(),[],"no");
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display=""};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display="none"};};}else{('CM_OpeningTagSymbolp id="EndPageParagraph" style="color:red;"  > There are no more questions. This concludes this page. <CM_FORWARDSLASHp>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertbefore, cm_inserttarget=CM_ParentObject.DoNotChange_AnswerButton,name= EndPageParagraph");
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display="none"};};}}else{if(
CaluMath.Html.ComparisonOneTerm(RemovePreviousQuestions,"e","yes")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["QuestionParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style.display="none"};};}if(
CaluMath.Html.ComparisonOneTerm(RemovePreviousAnswers,"e","yes")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].style.display="none"};};}
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove!=null){window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove()};};
CaluMath.Html.DefinedConstant("DoNotChange_QuestionIndex".cm_javascript(),"DoNotChange_QuestionIndex+1",5,"");
CaluMath.Html.DefinedConstant("DoNotChange_QuestionNumber".cm_javascript(),DoNotChange_QuestionNumberArray[DoNotChange_QuestionIndex],"no");
CaluMath.Html.DefinedConstant("DoNotChange_DisplayedQuestionNumber".cm_javascript(),DoNotChange_DisplayedQuestionNumberArray[DoNotChange_QuestionIndex],"no");
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display=""};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["SkippedQuestionParagraph".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["SkippedQuestionParagraph".cm_javascript()].remove!=null){window["CM_MainWindow".cm_javascript()]["SkippedQuestionParagraph".cm_javascript()].remove()};};
window["Questioncm_eval(DoNotChange_QuestionNumber)Routine".cm_javascript()]();
if(
CaluMath.Html.ComparisonOneTerm(ViewTextBoxArray[DoNotChange_QuestionNumber-1],"e","yes")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display=""};};
eval("CM_ParentObject.AnswerBox".cm_javascript()).cm_puttext("".cm_escapedoublequotes().cm_adjustquotes("'").cm_unescapebackslashes().cm_unescapequotes().cm_javascript().cm_unicode());}else{
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display="none"};};
eval("CM_ParentObject.AnswerBox".cm_javascript()).cm_puttext("".cm_escapedoublequotes().cm_adjustquotes("'").cm_unescapebackslashes().cm_unescapequotes().cm_javascript().cm_unicode());}
CaluMath.Html.DefinedConstant("DoNotChange_CurrentQuestionPreparationRoutine".cm_javascript(),cm_eval("Questioncm_eval(DoNotChange_QuestionNumber)PreparationRoutine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentGetTextboxAnswerRoutine".cm_javascript(),cm_eval("GetTextboxAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentBeforeCheckingAnswerRoutine".cm_javascript(),cm_eval("BeforeCheckingAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentCheckingAnswerRoutine".cm_javascript(),cm_eval("CheckingAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentCorrectAnswerRoutine".cm_javascript(),cm_eval("CorrectAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentIncorrectAnswerRoutine".cm_javascript(),cm_eval("IncorrectAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
CaluMath.Html.DefinedConstant("DoNotChange_CurrentCreateAfterStudentAnswerRoutine".cm_javascript(),cm_eval("CreateAfterStudentAnswercm_eval(DoNotChange_QuestionNumber)Routine"),"no");
window["DoNotChange_SkipQuestionVisibilityRoutine".cm_javascript()]();
window["DoNotChange_AxesVisibilityRoutine".cm_javascript()](AxesVisibilityArray[DoNotChange_QuestionNumber-1]);
window["DoNotChange_CurrentQuestionPreparationRoutine".cm_javascript()]();}};
eval("CM_ParentObject.DoNotChange_AnswerButton".cm_javascript()).cm_add(function(){
window["DoNotChange_AnswerButtonRoutine".cm_javascript()]();});
DoNotChange_AnswerButtonRoutine=function(){if(
CaluMath.Html.ComparisonOneTerm(ViewTextBoxArray[DoNotChange_QuestionNumber-1],"e","yes")=="yes"){
window["DoNotChange_CurrentGetTextboxAnswerRoutine".cm_javascript()]();
if(StudentAnswer==null){return;};}
window["RemoveWhenClickingCheckAnswerButtonAfterWrongAnswerRoutine".cm_javascript()]();
window["DoNotChange_CurrentBeforeCheckingAnswerRoutine".cm_javascript()]();
window["DoNotChange_CurrentCheckingAnswerRoutine".cm_javascript()]();
if(
CaluMath.Html.ComparisonOneTerm(StudentAnswerComparison,"e","yes")=="yes"){
window["DoNotChange_CorrectAnswerRoutine".cm_javascript()]();}else{
window["DoNotChange_IncorrectAnswerRoutine".cm_javascript()]();}
window["DoNotChange_CurrentCreateAfterStudentAnswerRoutine".cm_javascript()]();};
DoNotChange_CorrectAnswerRoutine=function(){
DoNotChange_ResultArray[DoNotChange_QuestionNumber-1].push(1);
window["DoNotChange_CurrentCorrectAnswerRoutine".cm_javascript()]();
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display=""};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove!=null){window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove()};};
setTimeout("CaluMath.Html.Focus(CM_MainWindow.CM_ParentObject.DoNotChange_AfterInputBoxFocus, CM_MainWindow)",500);
window["RemoveWhenClickingCheckAnswerButtonAfterWrongAnswerRoutine".cm_javascript()]();};
DoNotChange_IncorrectAnswerRoutine=function(){
DoNotChange_ResultArray[DoNotChange_QuestionNumber-1].push(0);
CaluMath.Html.DefinedConstant("DoNotChange_IncorrectAnswerParagraphColor".cm_javascript(),IncorrectAnswerParagraphColorArray[DoNotChange_IncorrectAnswerParagraphColorIndex%IncorrectAnswerParagraphColorArray.length],"no");
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove!=null){window["CM_MainWindow".cm_javascript()]["IncorrectAnswerParagraphcm_eval(DoNotChange_QuestionNumber)".cm_javascript()].remove()};};
window["DoNotChange_CurrentIncorrectAnswerRoutine".cm_javascript()]();
setTimeout("CaluMath.Html.Focus(CM_MainWindow.CM_ParentObject.DoNotChange_AfterInputBoxFocus, CM_MainWindow)",500);
CaluMath.Html.DefinedConstant("DoNotChange_IncorrectAnswerParagraphColorIndex".cm_javascript(),"DoNotChange_IncorrectAnswerParagraphColorIndex+1",5,"yes");
if(
CaluMath.Html.ComparisonOneTerm(DoNotChange_AllowMultipleAttemptsArray[DoNotChange_QuestionIndex],"e","no")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display=""};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_AnswerButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["AnswerBox".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display="none"};};}};
DoNotChange_AxesVisibilityRoutine=function(){
CaluMath.Html.DefinedConstant("DoNotChange_CurrentAxesVisibility".cm_javascript(),arguments[0],"no");
if(
CaluMath.Html.Comparison([[CaluMath.Html.Comparison([[DoNotChange_CurrentAxesVisibility,"e","no",],[DoNotChange_CurrentAxesVisibility,"e","r"]],"or"),"e","yes"],[DoNotChange_CurrentAxesVisibility,"e","n"]],"or")=="yes"){
if(window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript())!=null){if(window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style!=null&&window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style.display!=null){window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style.display="none"};};}else if(
CaluMath.Html.Comparison([[CaluMath.Html.Comparison([[DoNotChange_CurrentAxesVisibility,"e","yes",],[DoNotChange_CurrentAxesVisibility,"e","l"]],"or"),"e","yes"],[DoNotChange_CurrentAxesVisibility,"e","b"]],"or")=="yes"){
if(window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript())!=null){if(window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style!=null&&window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style.display!=null){window.document.getElementById("MultipleQuestionTemplate_Axes1Container".cm_javascript()).style.display=""};};}if(
CaluMath.Html.Comparison([[CaluMath.Html.Comparison([[DoNotChange_CurrentAxesVisibility,"e","no",],[DoNotChange_CurrentAxesVisibility,"e","yes"]],"or"),"e","yes"],[CaluMath.Html.Comparison([[DoNotChange_CurrentAxesVisibility,"e","l",],[DoNotChange_CurrentAxesVisibility,"e","n"]],"or"),"e","yes"]],"or")=="yes"){
if(window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript())!=null){if(window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style!=null&&window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style.display!=null){window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style.display="none"};};}else if(
CaluMath.Html.Comparison([[DoNotChange_CurrentAxesVisibility,"e","r",],[DoNotChange_CurrentAxesVisibility,"e","b"]],"or")=="yes"){
if(window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript())!=null){if(window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style!=null&&window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style.display!=null){window.document.getElementById("MultipleQuestionTemplate_Axes2Container".cm_javascript()).style.display=""};};}};
DoNotChange_SkipQuestionVisibilityRoutine=function(){if(
CaluMath.Html.ComparisonOneTerm(AllowSkipQuestionButton,"e","yes")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_SkipQuestionButton".cm_javascript()].style.display=""};};}};
DoNotChange_CreateConstantsRoutine=function(){
CaluMath.Html.DefinedConstant("DoNotChange_QuestionNumber".cm_javascript(),"0",5,"");
CaluMath.Html.DefinedConstant("DoNotChange_QuestionNumberArray".cm_javascript(),QuestionNumberArray,"no");
CaluMath.Html.DefinedConstant("DoNotChange_DisplayedQuestionNumberArray".cm_javascript(),[],"no");
CaluMath.Html.DefinedConstant("DoNotChange_QuestionIndex".cm_javascript(),"-1",5,"");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedQuestionArray".cm_javascript(),[],"no");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedQuestionCounterArray".cm_javascript(),[],"no");
CaluMath.Html.DefinedConstant("DoNotChange_SkippedDisplayedQuestionArray".cm_javascript(),[],"no");
for(i=0;i<QuestionNumberArray.length;i++){
CaluMath.Html.DefinedConstant("DoNotChange_DisplayedQuestionNumberArray".cm_javascript(),DoNotChange_DisplayedQuestionNumberArray.cm_concat(i+1),"no");};
DoNotChange_CurrentQuestionPreparationRoutine=function(){};
CaluMath.Html.DefinedConstant("DoNotChange_AllowMultipleAttemptsArray".cm_javascript(),AllowMultipleAttemptsArray,"no");
CaluMath.Html.DefinedConstant("DoNotChange_ResultArray".cm_javascript(),[],"no");
for(i=0;i<QuestionNumberArray.length;i++){
DoNotChange_ResultArray[i]=[QuestionNumberArray[i]];;};};
DoNotChange_CalculatorVisibilityRoutine=function(){if(
CaluMath.Html.ComparisonOneTerm(DisplayCalculatorButton,"e","yes")=="yes"){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_Calculator_StudentCalculator".cm_javascript()].style.display=""};};
"<br>".cm_html("cm_caswindow=CM_MainWindow,cm_insertoption=cm_insertbefore,cm_inserttarget=CM_ParentObject.DoNotChange_Calculator_StudentCalculator,cm_onlyforlists=no,name=DoNotChange_StudentCalculatorLineBreak");}};
DoNotChange_DisplayZoomButtonsRoutine=function(){if(
CaluMath.Html.ComparisonOneTerm(DisplayZoomButtons,"e","yes")=="yes"){
window["UnHideZoomButtonsRoutine".cm_javascript()]();}else{
window["HideZoomButtonsRoutine".cm_javascript()]();}};
HideDisplayQuestionButton=function(){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display="none"};};};
UnhideDisplayQuestionButton=function(){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_DisplayQuestionButton".cm_javascript()].style.display=""};};};
HideZoomButtonsRoutine=function(){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style.display="none"};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].hide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].hide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style.display="none"};};};
UnHideZoomButtonsRoutine=function(){
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomInButton".cm_javascript()].style.display=""};};
if(window["CM_MainWindow".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()]!=null){if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].unhide!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].unhide()};if(window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style!=null&&window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style.display!=null){window["CM_MainWindow".cm_javascript()]["CM_ParentObject".cm_javascript()]["DoNotChange_ZoomOutButton".cm_javascript()].style.display=""};};};
window["DoNotChange_CreateConstantsRoutine".cm_javascript()]();
if(cm_onloadbegun!="yes"){cm_onloadarray=cm_onloadarray.concat(function(){CM_MainWindow.DoNotChange_CalculatorVisibilityRoutine();})}else{CM_MainWindow.DoNotChange_CalculatorVisibilityRoutine();};
if(cm_onloadbegun!="yes"){cm_onloadarray=cm_onloadarray.concat(function(){CM_MainWindow.DoNotChange_AxesVisibilityRoutine(InitialAxesVisibility);})}else{CM_MainWindow.DoNotChange_AxesVisibilityRoutine(InitialAxesVisibility);};
window["DoNotChange_DisplayZoomButtonsRoutine".cm_javascript()]();
DoNotChange_BeforeQuestion1Routine=function(){
window["BeforeQuestion1Routine".cm_javascript()]();};
window["DoNotChange_BeforeQuestion1Routine".cm_javascript()]();
"<br>".cm_html("cm_caswindow=CM_MainWindow,cm_insertoption=n/a,cm_inserttarget=n/a,cm_onlyforlists=no,name=DoNotChange_LineBreak2");
"<br>".cm_html("cm_caswindow=CM_MainWindow,cm_insertoption=n/a,cm_inserttarget=n/a,cm_onlyforlists=no,name=DoNotChange_LineBreak3");
CM_ParentObject.cm_writefocusobject("name=DoNotChange_AfterInputBoxFocus,cm_caswindow=CM_MainWindow,cm_insertoption=n/a,cm_inserttarget=n/a");
DoNotChange_CreateCopyQuestionItems=function(){
if((window.opener!=null&&window.opener.CaluMath!=null&&window.opener.CaluMath.PM.PageMakerObjectArray!=null)||(window.parent!=null&&window.parent.CaluMath!=null&&window.parent.CaluMath.PM.PageMakerObjectArray!=null)){var tablenode=document.createElement("table");var tablebodynode=document.createElement("tbody");var trnode=document.createElement("tr");var td1node=document.createElement("td");var td1node=document.createElement("td");var td2node=document.createElement("td");var td3node=document.createElement("td");var td4node=document.createElement("td");var td5node=document.createElement("td");var td6node=document.createElement("td");tablenode.setAttribute("border","2px");tablenode.style.border="5px";tablenode.style.borderStyle="groove";var textnode1=document.createTextNode("Copy This Question: ");var originalproblemnumber=document.createElement("input");originalproblemnumber.setAttribute("type","text");originalproblemnumber.setAttribute("size","5");originalproblemnumber.setAttribute("id","twelvequestiontemplatecopyproblembox1");var newproblemnumber=document.createElement("input");newproblemnumber.setAttribute("type","text");newproblemnumber.setAttribute("size","5");newproblemnumber.setAttribute("id","twelvequestiontemplatecopyproblembox2");var copybutton=document.createElement("input");copybutton.setAttribute("type","button");copybutton.setAttribute("value","Copy Question");var dropdownmenu=document.createElement("select");dropdownmenu.setAttribute("id","twelvequestiontemplatedropdownmenu");var pElement=new Option("And Paste Copied Question Before Question ","before");dropdownmenu.options[dropdownmenu.options.length]=pElement;var pElement=new Option("And Paste Copied Question After Question ","after");dropdownmenu.options[dropdownmenu.options.length]=pElement;var pElement=new Option("And Use Copied Question Instead Of ","instead");dropdownmenu.options[dropdownmenu.options.length]=pElement;var instructionparagraph=document.createElement("p");instructionparagraph.setAttribute("id","twelvequestiontemplateparagraph");instructionparagraph.style.display="none";var instructiontextnode=document.createTextNode("Use this table to create a new question by using a copy of an existing question. For example, suppose you constructed Question1 and you want to create three more questions which are similar. You can copy Question1 and over-write Questions 2, 3 and 4 with it. Or, suppose you have constructed Questions 1 through 6, and then realize you would like to place a new question, which is similar to Question5 between Question2 and Question3. You can create a copy of Question5 and place it after Question2. To do do any of these things, enter the number of the question to be copied in the first textbox. If you want to copy a new, blank, template question, instead of a number enter a T in the first textbox. In the second textbox enter the number of the question that you want the copy to either over-write, or be placed before or after. From the drop-down menu, select how you want the copied question to be placed relative to the question whose number you entered in the second textbox. Note that, after placing the copy before or after a question, subsequent questions will have their numbers increased by 1. For example, if you place a copy of a question after Question5, the copy becomes Question6 and the original Question6 becomes Question7 and so on. Similarly, if you place a copy of a question before Question5, the copy becomes Question5 and the original Question5 becomes Question6. After copying questions, make sure you adjust the QuestionNumberArray, ViewTextBoxArray, AllowMultipleAttemptsArray and AxesVisibilityArray, since the numbering of the questions may now be different.  ");var viewinstructionsbutton=document.createElement("input");viewinstructionsbutton.setAttribute("type","button");viewinstructionsbutton.setAttribute("value","View Copy Instructions");viewinstructionsbutton.setAttribute("id","twelvequestiontemplateviewinstructionsbutton");var hideinstructionsbutton=document.createElement("input");hideinstructionsbutton.setAttribute("type","button");hideinstructionsbutton.setAttribute("value","Hide Copy Instructions");hideinstructionsbutton.setAttribute("id","twelvequestiontemplatehideinstructionsbutton");hideinstructionsbutton.style.display="none";tablenode.appendChild(tablebodynode);tablebodynode.appendChild(trnode);trnode.appendChild(td1node);trnode.appendChild(td2node);trnode.appendChild(td3node);trnode.appendChild(td4node);trnode.appendChild(td5node);trnode.appendChild(td6node);td1node.appendChild(textnode1);td2node.appendChild(originalproblemnumber);td3node.appendChild(dropdownmenu);td4node.appendChild(newproblemnumber);td5node.appendChild(copybutton);td6node.appendChild(viewinstructionsbutton);td6node.appendChild(hideinstructionsbutton);instructionparagraph.appendChild(instructiontextnode);document.body.appendChild(tablenode);document.body.appendChild(instructionparagraph);viewinstructionsbutton.onclick=function(){var hideinstructionsbutton=document.getElementById("twelvequestiontemplatehideinstructionsbutton");hideinstructionsbutton.style.display="";var instructionparagraph=document.getElementById("twelvequestiontemplateparagraph");instructionparagraph.style.display="";var viewinstructionsbutton=document.getElementById("twelvequestiontemplateviewinstructionsbutton");viewinstructionsbutton.style.display="none";};hideinstructionsbutton.onclick=function(){var hideinstructionsbutton=document.getElementById("twelvequestiontemplatehideinstructionsbutton");hideinstructionsbutton.style.display="none";var instructionparagraph=document.getElementById("twelvequestiontemplateparagraph");instructionparagraph.style.display="none";var viewinstructionsbutton=document.getElementById("twelvequestiontemplateviewinstructionsbutton");viewinstructionsbutton.style.display="";};copybutton.onclick=function(){var originalproblemnumber=document.getElementById("twelvequestiontemplatecopyproblembox1").value.replace(/s*/g,"");var newproblemnumber=document.getElementById("twelvequestiontemplatecopyproblembox2").value.replace(/s*/g,"");var copytype=document.getElementById("twelvequestiontemplatedropdownmenu").options[document.getElementById("twelvequestiontemplatedropdownmenu").selectedIndex].value;if(originalproblemnumber.length==0||newproblemnumber.length==0){return alert("You have either not entered the number of a Question to copy in the first text box or not entered the number of a Question in the second textbox that the copied question should over-write or be placed before or after.");}if(window.opener!=null&&window.opener.CaluMath!=null&&window.opener.CaluMath.PM.PageMakerObjectArray!=null){var TopWindow=window.opener;}else{var TopWindow=window.top;}return TopWindow.CaluMath.PM.QuestionTemplateCutAndPasteQuestion(originalproblemnumber,newproblemnumber,copytype);};};};
window["DoNotChange_CreateCopyQuestionItems".cm_javascript()]();
DoNotChange_QuestionTemplateRoutine=function(){
DoNotChange_QuestionTemplatePreparationRoutine=function(){('CM_OpeningTagSymbolp id="DoNotChange_QuestionParagraphTemplate" style="color:cm_eval(QuestionParagraphColor);"  >Question cm_eval(DoNotChange_DisplayedQuestionNumber):  Type Question Number cm_eval(DoNotChange_DisplayedQuestionNumber) here. A suggested ending for the question is the following: After you have done this, click the Check Answer button.<CM_FORWARDSLASHp>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertin, cm_inserttarget=QuestionContainer,name= DoNotChange_QuestionParagraphTemplate");};
DoNotChange_GetTextboxAnswerTemplateRoutine=function(){
if(CaluMath.Html.IsEmptyString(eval("CM_ParentObject.AnswerBox".cm_javascript()).cm_node.value)=="yes"){return alert("You cannot leave the box blank. Please enter something in the box.");};window["DoNotChange_StudentAnswer".cm_javascript()]=eval("CM_ParentObject.AnswerBox".cm_javascript()).cm_node.value.cm_removeleadingandtrailingspaces();};
DoNotChange_BeforeCheckingAnswerTemplateRoutine=function(){};
DoNotChange_CheckingAnswerTemplateRoutine=function(){
StudentAnswerComparison=CaluMath.Html.ComparisonOneTerm(DoNotChange_StudentAnswer,"e","yes");};
DoNotChange_CorrectAnswerTemplateRoutine=function(){('CM_OpeningTagSymbolp id="DoNotChange_CorrectAnswerParagraphTemplate" style="color:cm_eval(CorrectAnswerParagraphColor);"  > Your response for Question cm_eval(DoNotChange_DisplayedQuestionNumber) was correct. Click the Display Question button to see the next question.  <CM_FORWARDSLASHp>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertin, cm_inserttarget=QuestionContainer,name= DoNotChange_CorrectAnswerParagraphTemplate");};
DoNotChange_IncorrectAnswerTemplateRoutine=function(){('CM_OpeningTagSymbolp id="DoNotChange_IncorrectAnswerParagraphTemplate" style="color:cm_eval(DoNotChange_IncorrectAnswerParagraphColor);"  > Your response for Question cm_eval(DoNotChange_DisplayedQuestionNumber) was not correct. If the Check Answer button is still visible, you may change your response and click the Check Answer button to try again. Otherwise, click the Display Question button so view the next problem.<CM_FORWARDSLASHp>').cm_html("cm_caswindow=CM_MainWindow, cm_insertoption=cm_insertin, cm_inserttarget=QuestionContainer,name= DoNotChange_IncorrectAnswerParagraphTemplate");};
DoNotChange_CreateAfterStudentAnswerTemplateRoutine=function(){};};};
